function [goalellipseH goalCMH]=drawellipse(xtarget, ytarget, Mtargetxx, Mtargetxy, Mtargetyy, color)

goalCMH = line(xtarget,ytarget,'marker','o', ... % use a line object to create a circle
'markerfacecolor','none', 'markeredgecolor',color,'color',color,'markersize',10);
% define the polygons that we will deform into ellipses
numellpts = 50;
% ellipsepoly = [];
% for i=1:numellpts
% ellipsepoly = cat(1,ellipsepoly,[cos(i*2*pi/numellpts)sin(i*2*pi/numellpts)]);
% end
ellipsepoly = cat(2, cos([1:numellpts]'*2*pi/numellpts),sin([1:numellpts]'*2*pi/numellpts)); % vectorize code

goalellipseH = patch('vertices',ellipsepoly,'faces',[1:numellpts],'edgecolor',color, ... % patch graphic object
'facecolor','none','LineWidth',2);
ellipsex = get(goalellipseH,'XData');
ellipsey = get(goalellipseH,'YData');

% goal statistics

% Mtarget = Mtarget * scale^(1)/factor ; % scaled moments --> unscaled geometrical moments
% M_xx = Mtargetxx - xtarget^2;
% M_xy = Mtargetxy - xtarget*ytarget;
% M_yy = Mtargetyy - ytarget^2;

M_xx = Mtargetxx;
M_xy = Mtargetxy;
M_yy = Mtargetyy;
inertiamat = [M_xx -M_xy;-M_xy M_yy];

[u,s,v] = svd(inertiamat);
xsize = sqrt(4*s(1,1));
ysize = sqrt(4*s(2,2));

% make the circle to an ellipse
newellipsex = xsize*ellipsex;
newellipsey = ysize*ellipsey;
set(goalellipseH,'XData',newellipsex,'YData',newellipsey); % update the goal object specifications
rotate(goalellipseH,[0 0 1], atan2(u(1,2),u(2,2))*180/pi, [0 0 0]);
newxdat = get(goalellipseH,'XData');
newydat = get(goalellipseH,'YData');
set(goalellipseH,'XData',newxdat+xtarget,'YData',newydat+ytarget); %translate the ellipse to the desired CM
end
