function makemovie(doit, varargin)
% doit: 1 means heed value_name, value combos; 0 means do not heed these values
% valid [value_name, value] combinations:

% open path & name
% close path & name
% addrate {slowdown value : 0 or 1 for none, 2 for 2 frames per, 3 
% for 3 frames etc}


% typical use:
% top of file DEFINE:
% GEN_MOV=1;
% top of file do:
% makemovie(GEN_MOV, 'open','C:\0maciver\ribbon')
% after figure do:                                                                                  % transfer each figure into one "slide" of the movie
% makemovie(GEN_MOV, 'addrate','0')
% bottom of file do:
% makemovie(GEN_MOV, 'close','')

% collection of lines:
% GEN_MOV=1;
% makemovie(GEN_MOV, 'open','C:\0maciver\ribbon')
% makemovie(GEN_MOV, 'addrate','0')
% makemovie(GEN_MOV, 'close','')


if doit
     persistent aviH                                                                                % aviH is an avifile object --- you have to use persistent variable, because in order to create a movie, makemovie has to be called many times, where the address is only given once. 
     for i=1:2:size(varargin,2)                                                                      % size returns the dimension of the array, for row vector, it's the 2nd dimension.
         switch varargin{i}
         case 'open'
             pathname = varargin{i+1};
             aviH = avifile(pathname, 'compression','none', ...
                 'quality', 100, 'fps', 30);
            
         case 'close'
             fprintf(1, 'created AVI file in %s\n', aviH.Filename);
             aviH = close(aviH);
             clear aviH                                                                             % then the persistent variable is cleared.     
             
         case 'addrate'
            
            frame = getframe(gcf);                                                                  %  gcf is handle of current figure, with this parameter, getframe() captures the entire interior of the current figure window. 
  %            figureH=gcf;
             slowdown = str2num(varargin{i+1});                                                     % use vargarin = {'total',2,'sum',5} to denote strings, but remember to use vargarin{i}, instead of vargarin[i] to pick the element out.
            
             if slowdown>0
                 for i=1:slowdown
                   
                     aviH = addframe(aviH, frame);                                                  % add a lot of current plot to the movie, in effect you slow down the whole movie at this point. Might be useful when you want to playback the movie very carefully at some point 
  %                    aviH = addframe(aviH,figureH);
                 end
             else

                 aviH = addframe(aviH, frame);
   %              aviH = addframe(aviH, figureH);
             end
            
         otherwise
             disp('invalid makemovie parameter type')
            
         end
        
     end
    
end

